/*
 *  http-  
 *  - .
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef WIN32
#include <windows.h>
#include <winsock2.h>
#else

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#define _REENTRANT    /* basic 3-lines for threads */
#include <pthread.h>
#include <signal.h>

#define LPVOID void*
#define BOOL int
#define TRUE 1
#define FALSE 0
#define DWORD long
#define WINAPI
#endif

#include "strutils.h"

#define TCP_PORT 9999

#define MAXLEN 256
#define BUFLEN 4096
#define MAXDIR 10

#define HM_TRAY (WM_USER+2)

extern void doCGI(char *request, FILE *out, char *base);
void ShowIndex(void);

struct sockaddr_in serv_addr;
u_long port=TCP_PORT;
struct protoent *PE;

char revobase[MAXLEN]=""; //   ReVo

struct {char *name; char *value;} DirList[MAXDIR]; //  

#ifdef WIN32
CRITICAL_SECTION GlobalCriticalSection;
char ExePath[256];
HWND hWind;
#endif

/* ***************** */

//   
void ClearDirList(void) {
  int i;
  for (i=0; i<MAXDIR; i++) {
    if (DirList[i].name) free(DirList[i].name);
    if (DirList[i].value) free(DirList[i].value);
    DirList[i].name=NULL; DirList[i].value=NULL;
  }
  revobase[0]=0;
} //ClearDirList

// 
void cutspaces (char *s) {
  char *p;
  p=strchr(s,' '); //   
  if (p) *p=0;
  p=strchr(s,'\t'); //   
  if (p) *p=0;
  if (s[0] && s[strlen(s)-1]!='/' && s[strlen(s)-1]!='\\')
      strcat(s,"/"); //   
} //cutspaces

char hrefrevo[]="\"http://reta-vortaro.de/revo/";//"\"http://purl.oclc.org/NET/voko/revo/";
char hrefrevolocal[MAXLEN];

//   
void LoadDirList(void) {
  FILE *F;
  char buf[MAXLEN],tmp[MAXLEN];
  int i,n;
  char *p,*pp;

  ClearDirList();
  F=fopen("config","r");
  if (F==NULL) return;
  i=0;
  while (!feof(F)) {
    fgets(buf,MAXLEN-1,F);
    if (feof(F)) break;
    p=buf;
    while (*p==' ' || *p=='\t') p++; //   
    if (*p==0 || *p=='#' || *p=='\n') continue;
    pp=strchr(buf,'\n');
    if (pp) *pp=0; // \n
    pp=strchr(buf,'\r');
    if (pp) *pp=0; // \r

    while (*p==' ' || *p=='\t') p++; //   

    pp=strchr(buf,'='); //     
    if (pp==NULL) {  //  - revobase
      if (revobase[0]==0)
        strcpy(revobase,p);
      cutspaces(revobase);
      continue;
    }
    *pp++=0;

    strcpy(tmp,p); // 
    cutspaces(tmp); //    
    DirList[i].name=(char*)malloc(strlen(tmp)+1);
    strcpy(DirList[i].name,tmp);

    while (*pp==' ' || *pp=='\t') pp++; //    
    strcpy(tmp,pp);
    cutspaces(tmp); //    
    DirList[i].value=(char*)malloc(strlen(tmp)+1);
    strcpy(DirList[i].value,tmp);

    i++;
    if (i>=MAXDIR) break;
  }
  fclose(F);

  if (revobase[0]==0)
    hrefrevolocal[0]=0;
  else {
    strcpy(tmp,"\"");
    strcat(tmp,revobase);
    n=strlen(hrefrevo);
    for (i=0; i<n; i++)
      hrefrevolocal[i]=' ';
    strcpy(hrefrevolocal+n-strlen(tmp), tmp);
    if (strcmp(hrefrevo,hrefrevolocal)==0)
      hrefrevolocal[0]=0;
  }
} //LoadDirList

//      
void SubstDir(char *request, char *name) {
  int i;

#ifdef WIN32
  EnterCriticalSection(&GlobalCriticalSection);
#endif
  strcpy(name,request);
  for (i=0; i<MAXDIR && DirList[i].name; i++) {
    if (strncmp(name,DirList[i].name,strlen(DirList[i].name))) continue;
    strcpy(name,DirList[i].value);
    strcat(name,request+strlen(DirList[i].name));
  }
#ifdef WIN32
  LeaveCriticalSection(&GlobalCriticalSection);
#endif
} //SubstDir

#ifdef WIN32
/* --- */
NOTIFYICONDATA nid;
HMENU Popup;
MENUITEMINFO MII1={sizeof(MENUITEMINFO),MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_TYPE,
  MFT_STRING,MFS_DEFAULT,1,
  NULL,NULL,NULL,23,"&Montru",6};
MENUITEMINFO MII2={sizeof(MENUITEMINFO),MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_TYPE,
  MFT_SEPARATOR,MFS_DISABLED,2,
  NULL,NULL,NULL,24,"",0};
MENUITEMINFO MII3={sizeof(MENUITEMINFO),MIIM_DATA|MIIM_ID|MIIM_STATE|MIIM_TYPE,
  MFT_STRING,MFS_ENABLED,3,
  NULL,NULL,NULL,25,"&Haltu",5};

int initTCP(void) {
  WSADATA wsaData;
  return WSAStartup(MAKEWORD(2,0), &wsaData);
} //initTCP

LRESULT CALLBACK WndProc (HWND hWindow, UINT Message,
    WPARAM wParam, LPARAM lParam) {
  POINT pt;

  switch (Message) {
   case WM_DESTROY:
    Shell_NotifyIcon(NIM_DELETE, &nid);
    exit(0);
    break;
   case WM_COMMAND:
    switch (LOWORD(wParam)) {
    case 1:
      ShowIndex();
      break;
    case 3:
      PostMessage(hWindow, WM_DESTROY, 0, 0);
      break;
    }
    break;
   case HM_TRAY:
    switch (lParam) {
     case WM_LBUTTONDBLCLK:
      ShowIndex();
      return 1;
     case WM_RBUTTONUP:
     case WM_LBUTTONDOWN:
      GetCursorPos(&pt);
      SetForegroundWindow(hWindow);
      TrackPopupMenu(Popup,TPM_RIGHTBUTTON,pt.x,pt.y,0,hWindow,NULL);
      return 1;
    }
    break;
  }
  return DefWindowProc(hWindow, Message, wParam, lParam);
} //WndProc
#endif
/* --- */

void doError(int sock) {
  char *p="HTTP/1.1 404 OK\n"
            "Connection: Keep-Alive\n"
            "Content-Length: 0\n"
            "Content-Type: text/html\n"
            "\n";
  //fprintf(stderr,"Error!\n");
  send(sock,p,strlen(p),0);
} //doError

char base[BUFLEN+16];
int nn=0;

char *mimetypes[][2] = {
{".gif","image/gif"},
{".jpg","image/jpeg"},
{".png","image/png"},
{".ico","image/x-bitmap"},
{".svg","image/svg+xml"},
{".js","application/x-javascript"},
{".css","text/css"},
{".htm","text/html"},
{".html","text/html"},
{NULL,NULL}
};

void substrevo(char *buf) {
  char *p;
  if (hrefrevolocal[0]==0) return;
  p=buf;
  while (p=strstr(p,hrefrevo))
    strncpy(p,hrefrevolocal,strlen(hrefrevo));
} //substrevo

/*
void writelog(char *s) {
  FILE *out;
  out=fopen("log","a");
  fprintf(out,"\n===\n%s\n===\n",s);
  fclose(out);
} //writelog
*/

//int num=0;

int thcnt=0;
//   -  http-
#ifdef WIN32
DWORD WINAPI ThreadFunc(LPVOID param) {
#else
void * ThreadFunc(LPVOID param) {
#endif
  int n,i;
  BOOL isCGI;
  char buf[BUFLEN],hdr[BUFLEN],host[BUFLEN];
  char name[MAXLEN],tmpname[MAXLEN],content[MAXLEN];
  char *p,*request;
  char *tmp;
  FILE *F;
  long sock;
  int Size;

  thcnt++;

  sock = (long)param;

  for (;;) {
      n=recv(sock,hdr,sizeof(hdr)-1,0);
      if (n<=0) break;
      hdr[n]=0;

      //fprintf(stderr,"%d <<%s>>",n,hdr);
      //   
      while (strstr(hdr,"\r\n\r\n")==NULL) {
          n=recv(sock,buf,sizeof(buf)-1,0);
          if (n<=0) break;
          buf[n]=0;
          //fprintf(stderr,"%d <<%s>>",n,buf);
          strcat(hdr,buf);
      }
      //fprintf(stderr,"===\n");

      host[0]=0;
      p=strstr(hdr,"Host: ");
      if (p) {
        char *pp;
        pp=host;
        p+=6;
        while (*p && *p!='\r' && *p!='\n')
          *pp++=*p++;
        *pp=0;
      }
      if (host[0])
        sprintf(base,"http://%s/",host);

      if (strncmp(hdr,"POST",4)==0) {
          p=strstr(hdr,"\r\n\r\n");
          if (p==NULL) break;
          p[3]='?';
          request=p+3;
          if (*(request+1)==0) // 
            recv(sock,request+1,sizeof(hdr)-1-(request+1-hdr),0);
      }
      else if (strncmp(hdr,"GET ",4)==0) {
          request=hdr+4;
          p=strchr(request,' ');
          if (p) *p=0;
      }
      else
          break;
      while (*request=='/') request++;  //  

      isCGI=FALSE;
      p=strchr(request,'?');  //cgi-
      if (p) {
        FILE *out;
#ifdef WIN32
        sprintf(tmpname,"%s/tmpeo%d.html",getenv("TEMP"),nn++);
#else
        sprintf(tmpname,"tmpeo%d.html",nn++);
#endif
        out=fopen(tmpname,"w");  //    cgi
        doCGI(p,out,base);
        fclose(out);
        isCGI=TRUE;
        request=tmpname;
      }

      //      
      if (!isCGI && (strchr(request,':') || strstr(request,".."))) {
        doError(sock);
        continue;
      }

      SubstDir(request,name); //  

      if ((name[0]==0) || (name[strlen(name)-1]=='/'))
        strcat(name,"index.html");

      //fprintf(stderr,"%d name='%s'\n\n",num++,name);

      F=fopen(name,"rb");
      if (F==NULL) {
        doError(sock);
        continue;
      }
      fseek(F,0,SEEK_END);
      Size=ftell(F);  //  
      fseek(F,0,SEEK_SET);

      //  
      for (i=0; mimetypes[i][0]; i++)
        if (strstr(name,mimetypes[i][0]))
          strcpy(content,mimetypes[i][1]);

      // http
      sprintf(buf,"HTTP/1.1 200 OK\n"
                  "Connection: Keep-Alive\n"
                  "Content-Length: %d\n"
                  "Content-Type: %s\n"
                  "\n",
              Size,content);

      // 
      send(sock,buf,strlen(buf),0);

      //  
      tmp=malloc(Size);
      fread(tmp,1,Size,F);
      substrevo(tmp);
      send(sock,tmp,Size,0);
      free(tmp);
      fclose(F);
      if (isCGI) unlink(name); //  
  } //for
#ifndef __WIN32__
  close(sock);
#else
  closesocket(sock);
#endif

  thcnt--;
  return 0;
} //ThreadFunc

#ifdef WIN32
void CheckExe() {
  FILE *F;
  F=fopen(ExePath,"r");
  if (F!=NULL) {
    fclose(F);
    return;
  }
  Shell_NotifyIcon(NIM_DELETE, &nid);
  exit(0);
}
#endif

#ifdef WIN32
DWORD WINAPI ThreadNotify(LPVOID param) {
  HWND HChange;
  HChange=FindFirstChangeNotification(".",0,
    FILE_NOTIFY_CHANGE_LAST_WRITE|FILE_NOTIFY_CHANGE_SIZE|FILE_NOTIFY_CHANGE_FILE_NAME);
  while (WaitForSingleObject(HChange,INFINITE)!=WAIT_ABANDONED) {
    EnterCriticalSection(&GlobalCriticalSection);
    CheckExe();
    LoadDirList();
    LeaveCriticalSection(&GlobalCriticalSection);
    FindNextChangeNotification(HChange);
  }
  FindCloseChangeNotification(HChange);
} //ThreadNotify
#endif

DWORD WINAPI MainThreadFunc(LPVOID param) {
  DWORD ThreadId;
  long sock;
  long ss = (long)param;

#ifdef WIN32
  CreateThread(NULL,0,ThreadNotify,NULL,0,&ThreadId);
#else
  pthread_t thr;
  pthread_attr_t attr;
  pthread_attr_init(&attr);
#endif

  for (;;) {
    sock=accept(ss,NULL,NULL);
    if (sock<0) exit(1);
#ifdef WIN32
    CreateThread(NULL,0,ThreadFunc,(LPVOID)sock,0,&ThreadId);
#else
    pthread_create(&thr,&attr,ThreadFunc,(LPVOID)sock);
#endif
  } //for
  return 0;
} //MainThreadFunc

BOOL openpage=TRUE;
char url[MAXLEN];

#ifdef WIN32
void ShowIndex(void) {
  if (openpage) ShellExecute(0,"open",url,NULL,NULL,SW_NORMAL);
} //ShowIndex
#else
void stop (int signo) {
} //stop
#endif

#ifdef WIN32
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      PSTR szCmdLine, int iCmdShow) {
#else
int main(int argc, char **argv) {
#define _argc argc
#define _argv argv
#endif
  int sock;
  DWORD MainThreadId;
#ifdef WIN32
  HWND hWindow;
  static WNDCLASSEX wc;
  MSG msg;
  HANDLE AppMutex;
#endif
  int i;
  long ss;

#ifndef WIN32
  signal(SIGTERM,stop);
  signal(SIGINT, stop);
  signal(SIGABRT,stop);
  signal(SIGQUIT,stop);
#endif

#ifdef WIN32
  strcpy(ExePath,_argv[0]);
#endif

  i=1;
  while (_argc>i) {
    if (strcmp(_argv[i],"-s")==0)
      openpage=FALSE;
    else
      sscanf(_argv[i],"%ld",&port);
    i++;
  }

  LoadDirList();

  sprintf(base,"http://localhost:%ld/",port);

  sprintf(url,"EoRu.html");

#ifdef WIN32
  AppMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, "EoRus");
  if (AppMutex) {
    if (openpage) ShowIndex();
    CloseHandle(AppMutex);
    return 0;
  }
  AppMutex = CreateMutex(NULL, FALSE, "EoRus");
  InitializeCriticalSection(&GlobalCriticalSection);

  wc.cbSize = sizeof(WNDCLASSEX);
  wc.style = 0;
  wc.lpfnWndProc = &WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(1));
  wc.lpszMenuName = NULL;
  wc.lpszClassName = "EoRus";
  RegisterClassEx(&wc);

  hWindow = CreateWindowEx(0, "EoRus", "EoRus", WS_POPUP,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 0, 0, hInstance, NULL);
  hWind=hWind;

  nid.cbSize = sizeof(NOTIFYICONDATA); // size
  nid.hWnd = hWindow; // window to receive notifications
  nid.uID = 1;
  nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
  nid.uCallbackMessage = HM_TRAY; // message sent to nid.hWnd
  nid.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(1));
  strcpy(nid.szTip,"Esperanta-Rusa Vortaro");
  Shell_NotifyIcon(NIM_ADD, &nid);
  Popup=CreatePopupMenu();
  InsertMenuItem(Popup,0,FALSE,&MII1);
  InsertMenuItem(Popup,0,FALSE,&MII2);
  InsertMenuItem(Popup,0,FALSE,&MII3);

  initTCP();
#endif

  PE = getprotobyname("tcp");
  ss = socket(AF_INET, SOCK_STREAM, PE->p_proto);

  serv_addr.sin_family = AF_INET;
  serv_addr.sin_port = htons(port);
  //serv_addr.sin_addr.s_addr = *(long*)(gethostbyname("localhost")->h_addr);
  if (bind(ss,(struct sockaddr*)&serv_addr,sizeof(serv_addr))) exit(1);
  if (listen(ss,SOMAXCONN/*10*/)) exit(1);

#ifdef WIN32
  CreateThread(NULL,0,MainThreadFunc,(LPVOID)ss,0,&MainThreadId);
  if (openpage) ShowIndex();
  openpage=TRUE;
#else
  MainThreadFunc((LPVOID)ss);
#endif

#ifdef WIN32
  while (GetMessage(&msg,/*0*/hWindow,0,0)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  DeleteCriticalSection(&GlobalCriticalSection);
  CloseHandle(AppMutex);
  WSACleanup();
#endif
} //main
